<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "emr_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EmrType".
 *
 * Columns in table "emr_type" available as properties of the model,
 * followed by relations of table "emr_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $type
 * @property string $driver
 * @property string $logo_path
 * @property integer $mi7_integration
 * @property integer $overbooking
 * @property integer $read_only_integration
 *
 * @property AccountEmr[] $accountEmrs
 */
abstract class BaseEmrType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'emr_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'EmrType|EmrTypes', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, driver', 'required'),
            array('name', 'length', 'max' => 20),
            array('type', 'length', 'max' => 10),
            array('driver, logo_path', 'length', 'max' => 255),
            array('mi7_integration, read_only_integration, sync_provider_practice_schedule, overbooking', 'numerical', 'integerOnly' => true),
            array('type', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, type, driver, sync_provider_practice_schedule', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'accountEmrs' => array(self::HAS_MANY, 'AccountEmr', 'emr_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'type' => Yii::t('app', 'Type'),
            'driver' => Yii::t('app', 'Driver'),
            'logo_path' => Yii::t('app', 'Logo'),
            'mi7_integration' => Yii::t('app', 'MI7 Integration'),
            'read_only_integration' => Yii::t('app', 'Read Only Integration'),
            'sync_provider_practice_schedule' => Yii::t('app', 'Sync Provider Practice Schedule'),
            'overbooking' => Yii::t('app', 'Overbooking'),
            'accountEmrs' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('type', $this->type, true);
        $criteria->compare('driver', $this->driver, true);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('mi7_integration', $this->mi7_integration, true);
        $criteria->compare('read_only_integration', $this->read_only_integration, true);
        $criteria->compare('sync_provider_practice_schedule', $this->sync_provider_practice_schedule, true);
        $criteria->compare('overbooking', $this->overbooking, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
